<template>
  <q-layout>
    <q-page-container>
      <q-page class="bg-grey-3">
        <top-banner />
        <div class="container">
          <div class="row q-pt-md">
            <div class="col-md-3 col-12">
              <div class="categories">
                <div class="text-h6">Danh mục</div>
                <ul class="list-categories">
                  <li v-for="cat of productCategories" :key="cat.id">
                    <router-link :to="`/category/${cat.id}`">{{cat.name}} ({{cat.numberOfProducts}})</router-link>
                  </li>
                </ul>
              </div>
              <div class="categories">
                <div class="text-h6">Nhãn hàng</div>
                <ul class="list-brands">
                  <li v-for="brand of productBrands" :key="brand.id">
                    <router-link
                      :to="`/brand/${brand.id}`"
                    >{{brand.name}} ({{brand.numberOfProducts}})</router-link>
                  </li>
                </ul>
              </div>
            </div>
            <div class="col-md-9 col-12">
              <list-products v-if="productBrand" :brand="productBrand" small />
            </div>
          </div>
        </div>
      </q-page>
    </q-page-container>
  </q-layout>
</template>

<script>
import { mapGetters, mapState, mapActions } from 'vuex';
import TopBanner from '~/components/user/TopBanner.vue';
import ListProducts from '~/components/user/ListProducts.vue';

export default {
  components: { TopBanner, ListProducts },
  meta() {
    return {
      title: `${
        this.productBrand ? this.productBrand.name : ''
      } - Viet Distribution`
    };
  },
  computed: {
    ...mapState({
      productCategories: state => state.productCategories.productCategories,
      productBrands: state => state.productBrands.productBrands
    }),
    ...mapGetters({
      getProductBrandById: 'productBrands/getProductBrandById'
    }),
    productBrand() {
      if (this.$route.params.id) {
        return this.getProductBrandById(this.$route.params.id);
      }
      return null;
    }
  },
  mounted() {
    this.getProductCategories({ limit: 12 });
    this.getProductBrands({ limit: 12 });
  },
  methods: {
    ...mapActions({
      getProductCategories: 'productCategories/getProductCategories',
      getProductBrands: 'productBrands/getProductBrands'
    })
  }
};
</script>

<style lang="scss" styled>
.list-categories,
.list-brands {
  list-style-type: none;
  padding: 0;

  a {
    color: rgba(0, 0, 0, 0.7);
    text-decoration: none;
  }
}
</style>
